Skip Menu |
 

This queue is for tickets about the Net-SSH-Perl CPAN distribution.

Report information
The Basics
Id: 7725
Status: resolved
Priority: 0/
Queue: Net-SSH-Perl

People
Owner: Nobody in particular
Requestors: abuttery [...] impactrx.com
Cc:
AdminCc:

Bug Information
Severity: Important
Broken in: 1.25
Fixed in: (no value)



Subject: makte test fails on weak reference in Packet.pm
Download (untitled) / with headers
text/plain 8.1k
I'm trying to install Net::SSH::Perl version 1.25 on Perl 5.6.1 on RedHat Linux AS 2.1. I've tried using CPAN and now I'm doing it manually. When I run 'make test', Net::SSH::Perl::Packet generates an error that "Weak references are not implemented in the version of perl at...". I have version 1.24 in a separate directory and get the same error message. Any assistance would be greatly appreciated. perl -V: Summary of my perl5 (revision 5.0 version 6 subversion 1) configuration: Platform: osname=linux, osvers=2.4.21-1.1931.2.393.entsmp, archname=i386-linux uname='linux porky.devel.redhat.com 2.4.21-1.1931.2.393.entsmp #1 smp thu aug 14 14:47:21 edt 2003 i686 unknown ' config_args='-des -Doptimize=-O2 -march=i386 -mcpu=i686 -Dcc=gcc -Dcf_by=Red Hat, Inc. -Dcccdlflags=-fPIC -Dinstallprefix=/usr -Dprefix=/usr -Darchname=i386-linux -Dvendorprefix=/usr -Dsiteprefix=/usr -Uusethreads -Uuseithreads -Uuselargefiles -Dd_dosuid -Dd_semctl_semun -Di_db -Di_ndbm -Di_gdbm -Di_shadow -Di_syslog -Dman3ext=3pm -Dinc_version_list=5.6.0/i386-linux 5.6.0' hint=recommended, useposix=true, d_sigaction=define usethreads=undef use5005threads=undef useithreads=undef usemultiplicity=undef useperlio=undef d_sfio=undef uselargefiles=undef usesocks=undef use64bitint=undef use64bitall=undef uselongdouble=undef Compiler: cc='gcc', ccflags ='-fno-strict-aliasing -I/usr/local/include', optimize='-O2 -march=i386 -mcpu=i686', cppflags='-fno-strict-aliasing -I/usr/local/include' ccversion='', gccversion='2.96 20000731 (Red Hat Linux 7.2 2.96-118.7.2)', gccosandvers='' intsize=4, longsize=4, ptrsize=4, doublesize=8, byteorder=1234 d_longlong=define, longlongsize=8, d_longdbl=define, longdblsize=12 ivtype='long', ivsize=4, nvtype='double', nvsize=8, Off_t='off_t', lseeksize=4 alignbytes=4, usemymalloc=n, prototype=define Linker and Libraries: ld='gcc', ldflags =' -L/usr/local/lib' libpth=/usr/local/lib /lib /usr/lib libs=-lnsl -ldl -lm -lc -lcrypt -lutil perllibs=-lnsl -ldl -lm -lc -lcrypt -lutil libc=/lib/libc-2.2.4.so, so=so, useshrplib=false, libperl=libperl.a Dynamic Linking: dlsrc=dl_dlopen.xs, dlext=so, d_dlsymun=undef, ccdlflags='-rdynamic' cccdlflags='-fPIC', lddlflags='-shared -L/usr/local/lib' Characteristics of this binary (from libperl): Compile-time options: Built under linux Compiled at Aug 18 2003 16:09:43 @INC: /usr/lib/perl5/5.6.1/i386-linux /usr/lib/perl5/5.6.1 /usr/lib/perl5/site_perl/5.6.1/i386-linux /usr/lib/perl5/site_perl/5.6.1 /usr/lib/perl5/site_perl/5.6.0/i386-linux /usr/lib/perl5/site_perl/5.6.0 /usr/lib/perl5/site_perl /usr/lib/perl5/vendor_perl/5.6.1/i386-linux /usr/lib/perl5/vendor_perl/5.6.1 /usr/lib/perl5/vendor_perl uname -a: Linux njcinvmln10 2.4.9-e.3smp #1 SMP Fri May 3 16:48:54 EDT 2002 i686 unknown Messages from 'make test': PERL_DL_NONLAZY=1 /usr/bin/perl -Iblib/arch -Iblib/lib -I/usr/lib/perl5/5.6.1/i386-linux -I/usr/lib/perl5/5.6.1 -e 'use Test::Harness qw(&runtests $verbose); $verbose=0; runtests @ARGV;' t/*.t t/01-compile........# Failed test (t/01-compile.t at line 5) t/01-compile........NOK 1# Tried to use 'Net::SSH::Perl'. # Error: Weak references are not implemented in the version of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 # BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm line 22. # Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. # BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. # Compilation failed in require at (eval 1) line 2. # Looks like you failed 1 tests of 1. t/01-compile........dubious Test returned status 1 (wstat 256, 0x100) DIED. FAILED test 1 Failed 1/1 tests, 0.00% okay t/02-buffer.........ok t/03-packet.........Weak references are not implemented in the version of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm line 22. Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. Compilation failed in require at t/03-packet.t line 20. BEGIN failed--compilation aborted at t/03-packet.t line 20. t/03-packet.........dubious Test returned status 255 (wstat 65280, 0xff00) DIED. FAILED tests 1-10 Failed 10/10 tests, 0.00% okay t/04-config.........Weak references are not implemented in the version of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm line 22. Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. Compilation failed in require at t/04-config.t line 13. BEGIN failed--compilation aborted at t/04-config.t line 13. t/04-config.........dubious Test returned status 255 (wstat 65280, 0xff00) DIED. FAILED tests 1-25 Failed 25/25 tests, 0.00% okay t/05-cipher.........ok t/06-circular.......Weak references are not implemented in the version of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm line 22. Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. Compilation failed in require at t/06-circular.t line 5. BEGIN failed--compilation aborted at t/06-circular.t line 5. t/06-circular.......dubious Test returned status 255 (wstat 65280, 0xff00) Failed Test Status Wstat Total Fail Failed List of Failed -------------------------------------------------------------------------------- t/01-compile.t 1 256 1 1 100.00% 1 t/03-packet.t 255 65280 10 10 100.00% 1-10 t/04-config.t 255 65280 25 25 100.00% 1-25 t/06-circular.t 255 65280 ?? ?? % ?? Failed 4/6 test scripts, 33.33% okay. 36/115 subtests failed, 68.70% okay. make: *** [test_dynamic] Error 2 If I change line 22 of Packet.pm as follows, I get a different error message #use Scalar::Util qw(weaken); use Scalar::Util; PERL_DL_NONLAZY=1 /usr/bin/perl -Iblib/arch -Iblib/lib -I/usr/lib/perl5/5.6.1/i386-linux -I/usr/lib/perl5/5.6.1 -e 'use Test::Harness qw(&runtests $verbose); $verbose=0; runtests @ARGV;' t/*.t t/01-compile........Useless use of hash element in void context at blib/lib/Net/SSH/Perl/Packet.pm line 29. t/01-compile........ok t/02-buffer.........ok t/03-packet.........Useless use of hash element in void context at blib/lib/Net/SSH/Perl/Packet.pm line 29. Can't call method "can" on an undefined value at blib/lib/Net/SSH/Perl/Packet.pm line 337. # Looks like your test died before it could output anything. t/03-packet.........dubious Test returned status 255 (wstat 65280, 0xff00) DIED. FAILED tests 1-10 Failed 10/10 tests, 0.00% okay t/04-config.........Useless use of hash element in void context at blib/lib/Net/SSH/Perl/Packet.pm line 29. t/04-config.........ok t/05-cipher.........ok t/06-circular.......Useless use of hash element in void context at blib/lib/Net/SSH/Perl/Packet.pm line 29. t/06-circular.......ok Failed Test Status Wstat Total Fail Failed List of Failed -------------------------------------------------------------------------------- t/03-packet.t 255 65280 10 10 100.00% 1-10 Failed 1/6 test scripts, 83.33% okay. 10/116 subtests failed, 91.38% okay. make: *** [test_dynamic] Error 29 I'm sure there's something simple that incorrect in my configuration, I just can't find it. Any assistance would be greatly appreciated.
From: abuttery [...] impactrx.com
Download (untitled) / with headers
text/plain 8.4k
[guest - Tue Sep 21 08:45:00 2004]: Show quoted text
> I'm trying to install Net::SSH::Perl version 1.25 on Perl 5.6.1 on > RedHat Linux AS 2.1. > > I've tried using CPAN and now I'm doing it manually. When I run 'make > test', Net::SSH::Perl::Packet generates an error that "Weak > references are not implemented in the version of perl at...". > > I have version 1.24 in a separate directory and get the same error > message. > > Any assistance would be greatly appreciated. > > perl -V: > Summary of my perl5 (revision 5.0 version 6 subversion 1) > configuration: > Platform: > osname=linux, osvers=2.4.21-1.1931.2.393.entsmp, archname=i386- > linux > uname='linux porky.devel.redhat.com 2.4.21-1.1931.2.393.entsmp #1 > smp thu aug 14 14:47:21 edt 2003 i686 unknown ' > config_args='-des -Doptimize=-O2 -march=i386 -mcpu=i686 -Dcc=gcc > -Dcf_by=Red Hat, Inc. -Dcccdlflags=-fPIC -Dinstallprefix=/usr > -Dprefix=/usr -Darchname=i386-linux -Dvendorprefix=/usr > -Dsiteprefix=/usr -Uusethreads -Uuseithreads -Uuselargefiles > -Dd_dosuid -Dd_semctl_semun -Di_db -Di_ndbm -Di_gdbm -Di_shadow > -Di_syslog -Dman3ext=3pm -Dinc_version_list=5.6.0/i386-linux 5.6.0' > hint=recommended, useposix=true, d_sigaction=define > usethreads=undef use5005threads=undef useithreads=undef > usemultiplicity=undef > useperlio=undef d_sfio=undef uselargefiles=undef usesocks=undef > use64bitint=undef use64bitall=undef uselongdouble=undef > Compiler: > cc='gcc', ccflags ='-fno-strict-aliasing -I/usr/local/include', > optimize='-O2 -march=i386 -mcpu=i686', > cppflags='-fno-strict-aliasing -I/usr/local/include' > ccversion='', gccversion='2.96 20000731 (Red Hat Linux 7.2 2.96- > 118.7.2)', gccosandvers='' > intsize=4, longsize=4, ptrsize=4, doublesize=8, byteorder=1234 > d_longlong=define, longlongsize=8, d_longdbl=define, > longdblsize=12 > ivtype='long', ivsize=4, nvtype='double', nvsize=8, Off_t='off_t', > lseeksize=4 > alignbytes=4, usemymalloc=n, prototype=define > Linker and Libraries: > ld='gcc', ldflags =' -L/usr/local/lib' > libpth=/usr/local/lib /lib /usr/lib > libs=-lnsl -ldl -lm -lc -lcrypt -lutil > perllibs=-lnsl -ldl -lm -lc -lcrypt -lutil > libc=/lib/libc-2.2.4.so, so=so, useshrplib=false, > libperl=libperl.a > Dynamic Linking: > dlsrc=dl_dlopen.xs, dlext=so, d_dlsymun=undef, ccdlflags='- > rdynamic' > cccdlflags='-fPIC', lddlflags='-shared -L/usr/local/lib' > > > Characteristics of this binary (from libperl): > Compile-time options: > Built under linux > Compiled at Aug 18 2003 16:09:43 > @INC: > /usr/lib/perl5/5.6.1/i386-linux > /usr/lib/perl5/5.6.1 > /usr/lib/perl5/site_perl/5.6.1/i386-linux > /usr/lib/perl5/site_perl/5.6.1 > /usr/lib/perl5/site_perl/5.6.0/i386-linux > /usr/lib/perl5/site_perl/5.6.0 > /usr/lib/perl5/site_perl > /usr/lib/perl5/vendor_perl/5.6.1/i386-linux > /usr/lib/perl5/vendor_perl/5.6.1 > /usr/lib/perl5/vendor_perl > > uname -a: > Linux njcinvmln10 2.4.9-e.3smp #1 SMP Fri May 3 16:48:54 EDT 2002 i686 > unknown > > Messages from 'make test': > PERL_DL_NONLAZY=1 /usr/bin/perl -Iblib/arch -Iblib/lib > -I/usr/lib/perl5/5.6.1/i386-linux -I/usr/lib/perl5/5.6.1 -e 'use > Test::Harness qw(&runtests $verbose); $verbose=0; runtests @ARGV;' > t/*.t > t/01-compile........# Failed test (t/01-compile.t at line 5) > t/01-compile........NOK 1# Tried to use 'Net::SSH::Perl'. > # Error: Weak references are not implemented in the version of > perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 > # BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm > line 22. > # Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. > # BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line > 6. > # Compilation failed in require at (eval 1) line 2. > # Looks like you failed 1 tests of 1. > t/01-compile........dubious > Test returned status 1 (wstat 256, 0x100) > DIED. FAILED test 1 > Failed 1/1 tests, 0.00% okay > t/02-buffer.........ok > t/03-packet.........Weak references are not implemented in the version > of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 > BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm > line 22. > Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. > BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. > Compilation failed in require at t/03-packet.t line 20. > BEGIN failed--compilation aborted at t/03-packet.t line 20. > t/03-packet.........dubious > Test returned status 255 (wstat 65280, 0xff00) > DIED. FAILED tests 1-10 > Failed 10/10 tests, 0.00% okay > t/04-config.........Weak references are not implemented in the version > of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 > BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm > line 22. > Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. > BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. > Compilation failed in require at t/04-config.t line 13. > BEGIN failed--compilation aborted at t/04-config.t line 13. > t/04-config.........dubious > Test returned status 255 (wstat 65280, 0xff00) > DIED. FAILED tests 1-25 > Failed 25/25 tests, 0.00% okay > t/05-cipher.........ok > t/06-circular.......Weak references are not implemented in the version > of perl at blib/lib/Net/SSH/Perl/Packet.pm line 22 > BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl/Packet.pm > line 22. > Compilation failed in require at blib/lib/Net/SSH/Perl.pm line 6. > BEGIN failed--compilation aborted at blib/lib/Net/SSH/Perl.pm line 6. > Compilation failed in require at t/06-circular.t line 5. > BEGIN failed--compilation aborted at t/06-circular.t line 5. > t/06-circular.......dubious > Test returned status 255 (wstat 65280, 0xff00) > Failed Test Status Wstat Total Fail Failed List of Failed >
-------------------------------------------------------------------------------- Show quoted text
> t/01-compile.t 1 256 1 1 100.00% 1 > t/03-packet.t 255 65280 10 10 100.00% 1-10 > t/04-config.t 255 65280 25 25 100.00% 1-25 > t/06-circular.t 255 65280 ?? ?? % ?? > Failed 4/6 test scripts, 33.33% okay. 36/115 subtests failed, 68.70% > okay. > make: *** [test_dynamic] Error 2 > > > If I change line 22 of Packet.pm as follows, I get a different error > message > #use Scalar::Util qw(weaken); > use Scalar::Util; > > PERL_DL_NONLAZY=1 /usr/bin/perl -Iblib/arch -Iblib/lib > -I/usr/lib/perl5/5.6.1/i386-linux -I/usr/lib/perl5/5.6.1 -e 'use > Test::Harness qw(&runtests $verbose); $verbose=0; runtests @ARGV;' > t/*.t > t/01-compile........Useless use of hash element in void context at > blib/lib/Net/SSH/Perl/Packet.pm line 29. > t/01-compile........ok > t/02-buffer.........ok > t/03-packet.........Useless use of hash element in void context at > blib/lib/Net/SSH/Perl/Packet.pm line 29. > Can't call method "can" on an undefined value at > blib/lib/Net/SSH/Perl/Packet.pm line 337. > # Looks like your test died before it could output anything. > t/03-packet.........dubious > Test returned status 255 (wstat 65280, 0xff00) > DIED. FAILED tests 1-10 > Failed 10/10 tests, 0.00% okay > t/04-config.........Useless use of hash element in void context at > blib/lib/Net/SSH/Perl/Packet.pm line 29. > t/04-config.........ok > t/05-cipher.........ok > t/06-circular.......Useless use of hash element in void context at > blib/lib/Net/SSH/Perl/Packet.pm line 29. > t/06-circular.......ok > Failed Test Status Wstat Total Fail Failed List of Failed >
-------------------------------------------------------------------------------- Show quoted text
> t/03-packet.t 255 65280 10 10 100.00% 1-10 > Failed 1/6 test scripts, 83.33% okay. 10/116 subtests failed, 91.38% > okay. > make: *** [test_dynamic] Error 29 > > I'm sure there's something simple that incorrect in my configuration, > I just can't find it. > > Any assistance would be greatly appreciated.
I managed to trace the problem to the Scalar::Util package which displays the "Weak references are not implemented in the version of perl" message when the "weaken" subroutine is imported. To get around the problem, I commented out the code in Scalar::Util that displays the error message and added an empty subroutine "weaken". I know this is the wrong way to fix it, but it works for our environment. I'd like to know what has to be done to get it to work correctly.
Date: Tue, 21 Sep 2004 11:43:11 -0500 (CDT)
From: Dave Rolsky <autarch [...] urth.org>
To: Guest via RT <bug-Net-SSH-Perl [...] rt.cpan.org>
Subject: Re: [cpan #7725] makte test fails on weak reference in Packet.pm
RT-Send-Cc:
Download (untitled) / with headers
text/plain 809b
On Tue, 21 Sep 2004, Guest via RT wrote: Show quoted text
> I managed to trace the problem to the Scalar::Util package which > displays the "Weak references are not implemented in the version of > perl" message when the "weaken" subroutine is imported. To get around > the problem, I commented out the code in Scalar::Util that displays the > error message and added an empty subroutine "weaken". I know this is > the wrong way to fix it, but it works for our environment. I'd like to > know what has to be done to get it to work correctly.
You need to install the XS version of Scalar::Util. Normally, if you just install it via CPAN, that's what will happen, as long as you have a compiler on your system. -dave /*=========================== VegGuide.Org Your guide to all that's veg. ===========================*/
Subject: make test fails on weak reference in Packet.pm
From: abuttery [...] impactrx.com
Download (untitled) / with headers
text/plain 113b
Thanks. I got and installed Scalar-List-Utils-1.14 from CPAN, manually installed it and now it's working fine.


This service is sponsored and maintained by Best Practical Solutions and runs on Perl.org infrastructure.

Please report any issues with rt.cpan.org to rt-cpan-admin@bestpractical.com.